<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "practice_office_hour".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "PracticeOfficeHour".
 *
 * Columns in table "practice_office_hour" available as properties of the model,
 * followed by relations of table "practice_office_hour" available as properties of the model.
 *
 * @property integer $id
 * @property integer $practice_id
 * @property integer $day_number
 * @property string $hours
 *
 * @property Practice $practice
 */
abstract class BasePracticeOfficeHour extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'practice_office_hour';
    }

    public static function representingColumn()
    {
        return 'day_number';
    }

    public function rules()
    {
        return array(
            array('practice_id, day_number, hours', 'required'),
            array('practice_id, day_number', 'numerical', 'integerOnly' => true),
            array('hours', 'length', 'max' => 50),
            array('day_number, hours', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, practice, day_number, hours', 'safe', 'on' => 'search'),
            array(
                'hours',
                'match',
                'pattern' => '/(^((0|1)\d|2[0-3])[:][0-5]\d[:][0-5]\d[ ][-][ ]((0|1)\d|2[0-3])[:][0-5]\d[:][0-5]\d$)/',
                'message' => 'Please enter a valid hour range'
            )
        );
    }

    public function relations()
    {
        return array(
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'practice_id' => Yii::t('app', 'Practice'),
            'day_number' => Yii::t('app', 'Day Number'),
            'hours' => Yii::t('app', 'Hours'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->with = array('practice');

        $criteria->compare('id', $this->id);
        $criteria->compare('practice.name', $this->practice, true);
        $criteria->compare('day_number', $this->day_number);
        $criteria->compare('hours', $this->hours, true);

        return new CActiveDataProvider(get_class($this), array('criteria' => $criteria, 'pagination' => array('pageSize' => 100)));
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'PracticeOfficeHour|PracticeOfficeHours', $n);
    }

}
